using namespace std;
#include<bits/stdc++.h>
#define ll long long
#define ld long double
#define pb push_back
#define endl "\n"
#define all(x) (x).begin(), (x).end()
const ll mod = 1e9 + 7;
const ll MAX = LLONG_MAX;

vector<vector<char>> vert, horz;
vector<pair<int, int>> dirs = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
ll n, m;
vector<vector<int>> vis;
bool val = 0;
void dfs(int i, int j, int ti, int tj, char col) {
    vis[i][j] = 1;
    if (i == ti && j == tj) {
        val = 1;
        return;
    }
    for (pair<int, int> dir : dirs) {
        int ni = i + dir.first, nj = j + dir.second;
        if (0 <= ni && ni < n && 0 <= nj && nj < m && !vis[ni][nj]) {
            if (i < n - 1 && nj == j && (col == vert[i][j] || col == 'n')) {
                dfs(ni, nj, ti, tj, vert[i][j]);
            } else if (j < m - 1 && ni == i && (col == horz[i][j] || col == 'n')) {
                dfs(ni, nj, ti, tj, horz[i][j]);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m;
    vert = vector<vector<char>> (n - 1, vector<char> (m));
    horz = vector<vector<char>> (n, vector<char> (m - 1));
    bool second_subtask = true;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j + 1 < m; ++j) {
            horz[i][j] = s[j];
            if (s[j] != 'B') {
                second_subtask = false;
            }
        }
    }
    for (int i = 0; i + 1 < n; ++i) {
        string s;
        cin >> s;
        for (int j = 0; j < m; ++j) {
            vert[i][j] = s[j];
            if (s[j] != 'R') {
                second_subtask = false;
            }
        }
    }
    ll q;
    cin >> q;
    while (q--) {
        int ai, bi, ci, di;
        cin >> ai >> bi >> ci >> di;
        ai--; bi--; ci--; di--;
        if (n == 1) {
            if (di < bi) swap(bi, di);
            set<ll> s;
            for (int i = bi; i < di; ++i) {
                s.insert(horz[0][i]);
            }
            cout << s.size() << endl;
        } else if (second_subtask) {
            if (ai == ci || di == bi) {
                cout << 1;
            } else {
                cout << 2;
            }
            cout << endl;
        } else {
            vis = vector<vector<int>> (n, vector<int> (m, 0));
            dfs(ai, bi, ci, di, 'n');
            if (val) cout << 1 << endl;
            else cout << 2 << endl;
        }
    }
}